calypso-init 4.58 KB
Newer Older
Joe Nahmias's avatar
Joe Nahmias committed
1
#!/bin/sh
Keith Packard's avatar
Keith Packard committed
2
### BEGIN INIT INFO
Joe Nahmias's avatar
Joe Nahmias committed
3 4 5
# Provides:          calypso
# Required-Start:    $network $remote_fs
# Required-Stop:     $remote_fs
Keith Packard's avatar
Keith Packard committed
6 7
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
Joe Nahmias's avatar
Joe Nahmias committed
8 9 10
# Short-Description: CalDAV/CardDAV server
# Description:       Calendar and Contact server over WebDAV
#                    using the CalDAV and CardDAV protocols
Keith Packard's avatar
Keith Packard committed
11 12 13
### END INIT INFO

# Author: Keith Packard <keithp@keithp.com>
Joe Nahmias's avatar
Joe Nahmias committed
14
# Author: Joe Nahmias <jello@debian.org>
15
# Author: Petter Reinholdtsen <pere@debian.org>
Keith Packard's avatar
Keith Packard committed
16 17

# PATH should only include /usr/* if it runs after the mountnfs.sh script
Joe Nahmias's avatar
Joe Nahmias committed
18 19
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Calypso CalDAV Server"
Keith Packard's avatar
Keith Packard committed
20
NAME=calypso
21 22 23 24 25 26
USER=calypso
GROUP=calypso
BINDIP=127.0.0.1
DAEMON=/usr/bin/$NAME
PIDFILE=/var/run/calypso/$NAME.pid
CALYPSO_OPTS="--daemon"
Keith Packard's avatar
Keith Packard committed
27 28 29 30 31 32 33

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

34 35 36 37 38 39 40 41
if [ "$BINDIP" ] ; then
    CALYPSO_OPTS="${CALYPSO_OPTS:+$CALYPSO_OPTS }--host=$BINDIP"
fi

if [ "$PIDFILE" ] ; then
    CALYPSO_OPTS="${CALYPSO_OPTS:+$CALYPSO_OPTS }--pid-file=$PIDFILE"
fi

Keith Packard's avatar
Keith Packard committed
42 43 44 45 46 47 48 49
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

Joe Nahmias's avatar
Joe Nahmias committed
50 51 52
#
# Check whether daemon starting is enabled
#
53 54 55 56 57 58 59 60 61
check_start_daemon()
{
    if [ "$DISABLE_CALPYSO" = "yes" ]; then
        [ "$VERBOSE" != no ] && \
            log_warning_msg "Not starting $NAME, disabled via /etc/default/$NAME"
        return 1
    else
        return 0
    fi
Joe Nahmias's avatar
Joe Nahmias committed
62 63
}

Keith Packard's avatar
Keith Packard committed
64 65 66 67 68
#
# Function that starts the daemon/service
#
do_start()
{
69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85
    # Return
    #   0 if daemon has been started
    #   1 if daemon was already running
    #   2 if daemon could not be started
    mkdir -p $(dirname $PIDFILE)
    chown $USER:$GROUP $(dirname $PIDFILE)
    start-stop-daemon \
        --quiet \
        --start \
        --chuid $USER \
        --pidfile $PIDFILE \
        --exec $DAEMON \
        -- $CALYPSO_OPTS \
        || return 2
    # Add code here, if necessary, that waits for the process to be ready
    # to handle requests from services started subsequently which depend
    # on this one.      As a last resort, sleep for some time.
Keith Packard's avatar
Keith Packard committed
86 87 88 89 90 91 92
}

#
# Function that stops the daemon/service
#
do_stop()
{
93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121
    # Return
    #   0 if daemon has been stopped
    #   1 if daemon was already stopped
    #   2 if daemon could not be stopped
    #   other if a failure occurred
    start-stop-daemon \
	--stop \
	--quiet \
	--retry=TERM/30/KILL/5 \
	--pidfile $PIDFILE \
	--name $NAME
    RETVAL="$?"
    [ "$RETVAL" = 2 ] && return 2
    # Wait for children to finish too if this is a daemon that forks
    # and if the daemon is only ever run from this initscript.
    # If the above conditions are not satisfied then add some other code
    # that waits for the process to drop all resources that could be
    # needed by services started subsequently.  A last resort is to
    # sleep for some time.
    start-stop-daemon \
	--stop \
	--quiet \
	--oknodo \
	--retry=0/30/KILL/5 \
	--exec $DAEMON
    [ "$?" = 2 ] && return 2
    # Many daemons don't delete their pidfiles when they exit.
    rm -f $PIDFILE
    return "$RETVAL"
Keith Packard's avatar
Keith Packard committed
122 123 124
}

case "$1" in
125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170
    start)
        check_start_daemon || exit 0
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_start
        case "$?" in
            0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
            2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
    stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
            0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
            2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
    status)
        status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
        ;;
    restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
            0|1)
                do_start
                case "$?" in
                    0) log_end_msg 0 ;;
                    1) log_end_msg 1 ;; # Old process is still running
                    *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
            *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
    *)
        echo "Usage: $0 {start|stop|status|restart|force-reload}" >&2
        exit 3
        ;;
Keith Packard's avatar
Keith Packard committed
171 172 173
esac

: